/*
	This script will use the MSXSL XML Stylesheet parser to
	convert an XML file plus its XSL stylesheet into HTML.
	
	Requirements: IE 4.0, MSXSL technology preview.
		This page will install the MSXSL parser onto your machine:
			http://www.microsoft.com/xml/xsl/XSLControlDemo/XSLControl.htm
		You can get more information on XSL (plus samples) at:
			http://www.microsoft.com/xml/xsl/

	TO USE:
		1. Bind this script to a button in HomeSite/CF Studio.
		2. Open an XML file in HomeSite/CF Studio.
		3. Run this script by clicking the button you created.
		   If the XML file contains an XML-STYLESHEET declaration, the
		   script will attempt to use that styelsheet.  Otherwise, it will
		   assume there is a file in the same directory with the same filename
		   but the extension ".XSL".
		   
	Of course, the MSXSL parser is beta software, if that, and doesn't support
	all XSL features, but it seems pretty darned fast (at least on my machine).
	
	If you have any comments or suggestions, please let me know.
	
	Joel Mueller
	Creative Internet Solutions
	jmueller@creativeis.com

*/

function Main() {
	var app = Application;
	var active = app.ActiveDocument;
	var curFile = active.Filename;
	var curPath = curFile.substring(0, curFile.lastIndexOf("\\") + 1);
	var XSLRoot = curFile.substring(0, curFile.lastIndexOf(".") + 1);
	var extension = curFile.substring(curFile.lastIndexOf(".") + 1, curFile.length);
	var bContinue = true;
	var UserResponse, StyleURL;

	if (active.Modified) {
		app.MessageBox("You must save the current document before continuing.", "XML to HTML", 0);
		bContinue = false;
	} else if (extension.toLowerCase() != "xml") {
		UserResponse = app.MessageBox("This function will only work on XML files.\nDo you wish to continue?", "XML to HTML", 3);
		if (UserResponse != 6) {
			bContinue = false;
		}
	}

	if (bContinue) {
		var objXSL = new ActiveXObject("XSLControl.XSLControl.1");
		// Check for xml-stylesheet declaration.
		var styleTag = /<\? *xml-stylesheet +href *= *\"([^\"]+)\"[^\n]*\?>/i;
		var strFile = active.Text;
		if (styleTag.test(strFile)) {
			StyleURL = RegExp.$1
			if (StyleURL.indexOf("\\") == -1 && StyleURL.indexOf("/") == -1) {
				StyleURL = curPath + StyleURL;
   			}
		} else {
			StyleURL = XSLRoot + "xsl";
		}
		
		objXSL.documentURL = curFile;
		objXSL.styleURL = StyleURL;
		var strHTML = objXSL.htmlText;
		
		app.NewDocument(false);
		app.ActiveDocument.Text = strHTML;
		app.CurrentView = 2;
	}
}
